#
#  rdsmetadata.py
#  ENRAGE
#
try:
    import psyco
    psyco.full()
except:
    pass

import sys
from commoncode import readDataset

print '%s: version 2.4' % sys.argv[0]
if len(sys.argv) < 2:
    print 'usage: python %s rdsfile [propertyName1::propertyValue1] ... [propertyNameN::propertyValueN] [-defaultcache size] [-index] [-dropindex] [-nocount] [-complexity]' % sys.argv[0]
    print '\nwhere the optional metadata name::value pairs are added to the existing dataset\n'
    sys.exit(1)

doCount = True
if '-nocount' in sys.argv:
    doCount = False

datafile = sys.argv[1]
rds = readDataset(datafile, verbose=True, reportCount=doCount)

cacheVal = 0
if '-defaultcache' in sys.argv:
    cacheVal = int(sys.argv[sys.argv.index('-defaultcache') + 1])
    rds.setDBcache(cacheVal, default=True)
    print "set default cache size to %d pages" % cacheVal

if '-dropindex' in sys.argv:
    try:
        rds.dropIndex()
    except:
        print 'could not drop index'

if '-index' in sys.argv:
    print "building index...."
    if cacheVal > 0:
        rds.buildIndex(cacheVal)
    else:
        rds.buildIndex()

if '-complexity' in sys.argv:
    print "calculating uniq read complexity..."
    uniqs = rds.getUniqsCount(distinct=False)
    distincts = rds.getUniqsCount(distinct=True)
    print '%d distincts / %d uniqs = %.2f' % (distincts, uniqs, float(distincts) / uniqs)

propertyList = []
for arg in sys.argv:
    if '::' in arg:
        (pname, pvalue) = arg.strip().split('::')
        print 'adding %s : %s' % (pname, pvalue)
        propertyList.append((pname, pvalue))
if len(propertyList) > 0:
    rds.insertMetadata(propertyList)



